#include <iostream>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++) cin>>a[i];
    int brp[32] = {};
    for(int i=0;i<n;i++){
        for(int j=0;j<32;j++){
            if(a[i]&(1<<j)) brp[j]++;
        }
    }
    int q;
    cin>>q;
    while(q--){
        int t;
        cin>>t;
        if(t==0){
            int k;
            cin>>k;
            int res = 0;
            for(int j=0;j<32;j++){
                if(brp[j]>=k) res+=(1<<j);
            }
            cout<<res<<endl;
        }
        if(t==1){
            int k;
            cin>>k;
            k--;
            int stari = a[k];
            int novi;
            cin>>novi;
            for(int j=0;j<32;j++){
                if(stari&(1<<j)) brp[j]--;
            }
            for(int j=0;j<32;j++){
                if(novi&(1<<j)) brp[j]++;
            }
        }
    }
}